#!BPY
""" Registration info for Blender menus
Name: 'ph_Outlines'
Blender: 231
Group: 'Misc'
Tooltip: 'Select outlines vertex of the selection.'
"""

#### !<>

########################################################
#													   #
#				 ph_Outlines.py						   #
#													   #
#		  Cree par coolphil@worldonline.fr			   #
#				  le 29/06/2004						   #
#													   #
#													   #
# http://hp.home.chez.tiscali.fr/re_illusion/index.htm #
#													   #
########################################################


###################
#
# PS: On peut deplacer le script en faisant:
#     Click maintenu (bouton gauche souris) sur
#     la barre de titre et deplacement de la souris.
#
#     Reinitialisation de la position par un simple
#     click bouton droit de la souris dans la fenetre
#     de script.
#
########################################################


import Blender
from Blender import Scene, Object, NMesh, Material, Draw, BGL
from Blender.Scene import Render
from Blender.BGL import *
from Blender.Draw import *
from math import *
from Blender.Noise import *


#### Global Variables #############

lastUndo = []
menu = Create(1)


###### Quelques couleurs #######
white = (1.0,1.0,1.0)
black = (0.0,0.0,0.0)
blue = (.71,.71,.76)
dgray = (.4,.4,.4)
red = (.7,.0,.3)
green = (.70,.75,.70)
back = (.7,.7,.7)
################################


H_Col = blue
Border = (H_Col[0]-.2,H_Col[1]-.2,H_Col[2]-.2)
Glanz = (H_Col[0]+.2,H_Col[1]+.2,H_Col[2]+.2)

BWidth = 250
BHeight = 170


scn = Scene.GetCurrent()
context = scn.getRenderingContext()

####### Variables pour le deplacement #######
mouse_x = 0									#
mouse_y = 0									#
											#
barStartx = 1								#
barStarty = BHeight - 35					#
barLenx = 195								#
barLeny = 35								#
											#
L_M = 0										#
v_x = 0										#
v_y = 0										#
Bposx = 0									#
Bposy = 0									#
lastBposx = 0								#
lastBposy = 0								#
#############################################



###################################

BL_VERSION = Blender.Get('version')
if (BL_VERSION<=223):
	import Blender210


################
def GL_Bx(vl=0):
################
	return (Bposx + vl)

################
def GL_By(vl=0):
################
	return (Bposy + vl)

#############################
def Ligne(y,xs=20,xe=BWidth):
#############################
	glRecti(xs,y,xe,y+1)

######################################
def Ligne3D(y,long,col,flat=20,xs=20):
######################################
	t= flat/100.0
	glColor3d(col[0]+t,col[1]+t,col[2]+t)
	Ligne(y,xs,xs+long)
	glColor3d(col[0]-t,col[1]-t,col[2]-t)
	Ligne(y+1,xs,xs+long)
	
#############################################################################
def Degrade(y,height,col,flat=10,xs=20,xe=BWidth,half=0,bizS=0,bizE=0):
#############################################################################
	if not((bizS == 0) or (bizS == -1) or (bizS == 1)):
		bizS = 0
 	if not((bizE == 0) or (bizE == -1) or (bizE == 1)):
		bizE = 0


	cC = 0
	cT = 1+half
	for cl in range(0, height, (1 - 2 * (height < 0))):
		incS = xs + ( height * cl/height * bizS)
		incE = xe + ( height * cl/height * bizE)

		cC = -cos(cl/float(height)*pi/(cT+(cT==0)))*flat/100
		glColor3d(col[0]+cC,col[1]+cC,col[2]+cC)
		Ligne(y+cl,incS,incE)


##################################################
def GL_Dot(x=10, y=10, col=(.71,.71,.76), flat=2):
##################################################
	DotList = ((-.05,-.1,-.1),(.05,.0,-.1),(.1,.05,-.05))
	glBegin(GL_POINTS)
	for ze in range(3):
		for sp in range(3):
			cC = DotList[ze][sp]*flat
			glColor3d(col[0]+cC,col[1]+cC,col[2]+cC)
			glVertex2i(x+sp,y+ze)
	glEnd()

##################################################################################
def GL_DotLine(x=10, y=10, long = 10, col=(.71,.71,.76), direction = "y", flat=5):
##################################################################################

	if direction == "x":
		for Dot_X in range(x, x+long, 10):
			GL_Dot(Dot_X, y, col, flat)

	else:
		for Dot_Y in range(y, y+long, 10):
			GL_Dot(x, Dot_Y, col, flat)

	return 0

########################################################################
def Relief_Text(x,y,t, colfrt=(1.0, 1.0, 1.0), colback=(0.0, 0.0, 0.0)):
########################################################################

	apply(glColor3f, colback)
	glRasterPos2f(x+1, y+3)
	Text(t)
	glRasterPos2f(x+1, y+4)
	Text(t)
	apply(glColor3f, colfrt)
	glRasterPos2f(x, y+5)
	Text(t)

	return 0



###############
def info_Obj(Ob=[]):
###############

	Obtype = 0
	mename = []
	me = []
	calque = 1

	if not Ob:
		if not Object.GetSelected():
			return Ob,Obtype,mename,me
		else:
			Ob = Object.GetSelected()[0]
			if (Ob.getType() == 'Mesh'):

				Obtype = 1
				calque = Ob.Layer                    # Le "layer" de l'object selectionne
				mename = Ob.getData().name
				me = Ob.getData()
	else:
		if (Ob.getType() == 'Mesh'):

			Obtype = 1
			calque = Ob.Layer                    # Le "layer" de l'object selectionne
			mename = Ob.getData().name
			me = Ob.getData()

	return Ob,Obtype,mename,me


#########################################
def D_Faces_f_VertAndD_Edges_f_Face(me):#
#########################################
# Dicos sous forme de NMesh.verts #
###################################

	D_ffv = {} ### DicoFacesfromVert={[NMVert]: [[NMFace],[NMFace],[NMFace]],  [NMVert]: [[NMFace],[NMFace]],  [NMVert]:  ...}
	D_eff = {} ### DicoEdgesfromFace={[NMFace]: [[NMVert,NMVert], [NMVert,NMVert],[NMVert,NMVert],[NMVert,NMVert]],  [NMFace]: [[NMVert,NMVert], [NMVert, ...}


	for x in me.verts:
		D_ffv[x] = []

	MeshFaces = me.faces

	for f in MeshFaces:
		lenF = len(f)

		D_eff[f] = []

		if lenF == 2:
			D_eff[f] = [f.v]

		else:

			for vidx in range(lenF):

				###### Section L_Ffv ##########
				if f not in D_ffv[f.v[vidx]]:
					D_ffv[f.v[vidx]].append(f)

				###### Section D_eff #########
				if vidx < (lenF-1):
					D_eff[f].append([f.v[vidx], f.v[vidx+1]])
				else:
					D_eff[f].append([f.v[vidx], f.v[0]])


	return D_ffv, D_eff

############################################################################
def ReturnFacesfromEdge(edge=[None,None], d_ffv={}, d_eff={}, selfFace=[]):#
############################################################################
# Retourne la liste des faces qui appartiennent a un edge donne #
#################################################################

#	print "1er vertice de l'edge  = ", edge[0]
#	print "2eme vertice de l'edge  = ", edge[1]

	if len(edge) > 2:
		error = "Error, an edge can be made by two and only two points !"
		raise error

	else:
#		print "d_ffv[edge[0]] = ", d_ffv[edge[0]]

		l_fcs = []
		[l_fcs.append(x) for x in d_ffv[edge[0]]]
		[l_fcs.append(x) for x in d_ffv[edge[1]]]
		reduce(l_fcs)

#		print "==== l_fcs =", l_fcs

		if selfFace:
			tp1 = []
			[tp1.append(x) for x in l_fcs]
			tp1.remove(selfFace)
			l_fcs = tp1

		l_ffe = []
		[l_ffe.append(f) for f in l_fcs if edge in d_eff[f] or (Swap2d(edge) in d_eff[f])]


	return l_ffe

######
def Swap2d(list=[None,None]):
######

	return [list[1], list[0]]


#######################
#### Fonction reduce ##
def reduce(list):     #
#######################

	list.sort()
	list.reverse()

	lenlist = len(list) - 1
	if lenlist > 0:
		compt = 0

		while compt < lenlist:

			if list[compt] == list[compt + 1]:
				list.remove(list[compt])
				lenlist -= 1

			else:
				compt += 1

	list.reverse()

	return list

######################
def Copy(ToCopy = []):
######################

	A = []
	[A.append(x) for x in ToCopy]

	return A

###########
def beep():
###########
	print "\a\r"

	return 0

########################
def TriageGrpFcs(ListF):
########################

	LF = Copy(ListF)
	GrNo = {}
	tpL = []
	compt = 1

	while len(LF):

		if len(LF):
			workF = LF.pop(0)

			ffv = []
			[ffv.extend(D_FacesfromVert[v]) for v in workF.v]

			for retFcs in ffv:

				if retFcs:
					if retFcs in LF:

						tpL.append(LF.pop(LF.index(retFcs)))

			tpL.insert(0, workF)

			if len(tpL) == 1:

				#### Face isole ####
				GrNo[compt] = [workF]
				tpL = []
				compt +=1

			else:

				#### On continue dans le groupe ####
				GrFpos = 1
				GrNo[compt] = tpL
				tpL = []

				while GrFpos < len(GrNo[compt]):

					workF = GrNo[compt][GrFpos]

					ffv = []
					[ffv.extend(D_FacesfromVert[v]) for v in workF.v]

					for retFcs in ffv:

						if retFcs:
							if retFcs in LF:

								tpL.append(LF.pop(LF.index(retFcs)))

					tptpL = GrNo[compt]
					tptpL.extend(tpL)
					GrNo[compt] = tptpL
					tpL = []

					GrFpos += 1

				compt += 1

#	print "Nous avons %s groupes." %(compt - 1)
#	print GrNo
#	print LF

	return GrNo

#######################
def Sel_OutLines(lFcs):
#######################

	WorkingVerts = [] ## Init.

	for f in lFcs:  ########## Boucle faces selectionnes #############

			for edg in D_EdgesfromFace[f]:

				RetFfE = ReturnFacesfromEdge(edg, D_FacesfromVert, D_EdgesfromFace, f)

				if  not RetFfE or (RetFfE[0] not in lFcs):

					WorkingVerts.extend(edg)


	WorkingVerts.sort()
	reduce(WorkingVerts)


	return WorkingVerts

###########
def Undo():
###########
	global lastUndo, Obj, mesh, meshname

	NMesh.PutRaw(lastUndo, meshname)
	Obj.makeDisplayList()

	lastUndo = []

	return 0


###########
def main():
###########
	global D_FacesfromVert, D_EdgesfromFace, lastUndo, Obj, mesh, meshname

	Obj,Objtype,meshname,mesh = info_Obj()

	if Objtype:
		if menu.val == 1:

			lastUndo = Obj.getData()

			print
			print "Working..."

			L_SelV = [] #### Liste des vertex selectionnes ####
			for v in mesh.verts:
				if v.sel:
					L_SelV.append(v)
				v.sel = 0

			#####################################
			#####################################
			print "Building ... DicoFacesfromVert"
			D_FacesfromVert, D_EdgesfromFace = D_Faces_f_VertAndD_Edges_f_Face(mesh)
			print "DicoFacesfromVert...OK"
			#####################################

			LF = []

			[LF.extend(D_FacesfromVert[vtc]) for vtc in L_SelV]
			reduce(LF)


			NewL_SelV = [] #### La nouvelle liste de vertex sur lequel nous allons travailler ####
			NewLF = [] #### La nouvelle liste de faces #####
			for f in LF:
				chk = []
				[chk.append(v) for v in f.v if v in L_SelV]
				if len(chk) == len(f.v):
					NewL_SelV.extend(f.v)
					NewLF.append(f)


			GrpFcs = TriageGrpFcs(NewLF)

			Vert_2_sel = [] #### La liste finale des vertex a selectionner ####
			for fcs in GrpFcs.keys():
				Vert_2_sel.extend(Sel_OutLines(GrpFcs[fcs]))

			for v in Vert_2_sel:
				v.sel = 1

			NMesh.PutRaw(mesh, meshname)
			mesh.update(0)
			Obj.makeDisplayList()

			print "OK...done."
			beep()


		elif menu.val == 2 and mesh.materials:

			if len(mesh.materials) > 1:

				lastUndo = Obj.getData()

				print
				print "Working..."

				#####################################
				#####################################
				print "Building ... DicoFacesfromVert"
				D_FacesfromVert, D_EdgesfromFace = D_Faces_f_VertAndD_Edges_f_Face(mesh)
				print "DicoFacesfromVert...OK"
				#####################################

				FacesMat = {}

				for m in range(len(mesh.materials)):
					FacesMat[m] = []
				for f in mesh.faces:
					FacesMat[f.mat].append(f)

				Vert_2_sel = [] #### La liste finale des vertex a selectionner ####

				for m in range(len(mesh.materials)):
					GrpFcs = TriageGrpFcs(FacesMat[m])

					for fcs in GrpFcs.keys():
						Vert_2_sel.extend(Sel_OutLines(GrpFcs[fcs]))

				reduce(Vert_2_sel)
				for v in mesh.verts:
					v.sel = 0
				for v in Vert_2_sel:
					v.sel = 1

				NMesh.PutRaw(mesh, meshname)
				mesh.update(0)
				Obj.makeDisplayList()

				print "OK...done."
				beep()

			else:
				print
				print "To work, object need 2 materials at least !"

	return 0

###########
def draw():
	global WindowSize, menu

	WindowSize = Buffer(GL_FLOAT, 4)
	glGetFloatv(GL_SCISSOR_BOX, WindowSize)
	WindowSize = WindowSize.list


	glClearColor(0.439, 0.533, 0.561, 0.0)
	glClear(GL_COLOR_BUFFER_BIT)

	Degrade(GL_By( 1), BHeight, (0.8, 0.8, 0.8), 20,GL_Bx(1),GL_Bx(BWidth), -0.4)

	Degrade(GL_By(BHeight -36), 35, (0.65, 0.7, 0.7), 35,GL_Bx(1),GL_Bx(BWidth - 1), 0.00)
	Degrade(GL_By(BHeight -36), 35, (0.65, 0.7, 0.7), 60,GL_Bx(1),GL_Bx(125), 0.44,0,1)

	Relief_Text(GL_Bx(20), GL_By(BHeight - 25),"ph_Outlines.py", (0.3,0.3,0.3), (0.962, 0.792, 0.566))

	GL_DotLine(GL_Bx(10), GL_By(10), BHeight - 50)
	GL_DotLine(GL_Bx(BWidth - 10), GL_By(10), BHeight - 50)

	Ligne3D(GL_By(10),55,(0.8, 0.8, 0.8),-30,GL_Bx(25))
	Ligne3D(GL_By(BHeight - 50),25,(0.8, 0.8, 0.8),-30,GL_Bx(BWidth - 50))

	name = "Mode : %t|By selected vertex %x1|Materials's seams %x2"
	menu = Menu(name, 4, GL_Bx(60), GL_By(BHeight - 70), 125, 20, menu.val)

	Button('Select Outlines', 1, GL_Bx(75), GL_By(52), 100, 30)
	Button('Undo', 3, GL_Bx(95), GL_By(15), 60, 22, 'Undo last action.')
	Button('Exit', 2, GL_Bx(198), GL_By(BHeight - 27), 45, 20, '')

####################
def event(evt, val):
	global mouse_x, mouse_y, L_M, L_Mx, L_My, v_x, v_y, barStartx, barStarty, Bposx, Bposy, lastBposx, lastBposy

	if ( evt == ESCKEY and not val):
		Exit()

	if (evt== QKEY and not val): Exit()




	############################################################################
	################################# Deplacements #############################

	if (evt == MOUSEX): mouse_x = int(val - WindowSize[0])
	if (evt == MOUSEY): mouse_y = int(val - WindowSize[1])

	if (evt == LEFTMOUSE and val) and (mouse_x in range(barStartx,barStartx+barLenx)) and (mouse_y in range(barStarty,barStarty+barLeny)):

		L_M = 1
		L_Mx = mouse_x
		L_My = mouse_y

	elif (evt == LEFTMOUSE and not val):
		L_M = 0
		barStartx += v_x
		barStarty += v_y

		lastBposx = Bposx
		lastBposy = Bposy
		v_x = 0
		v_y = 0

	
	if (evt == MOUSEX) and L_M:
		mouse_x = int(val - WindowSize[0])
		v_x = mouse_x - L_Mx
		Bposx = lastBposx + v_x
		Bposy = lastBposy + v_y
		Redraw()

	if (evt == MOUSEY) and L_M:
		mouse_y = int(val - WindowSize[1])
		v_y = mouse_y - L_My
		Bposx = lastBposx + v_x
		Bposy = lastBposy + v_y
		Redraw()

	if (evt == RIGHTMOUSE) and not L_M: #### Reinitialisation ####
		barStartx = 1
		barStarty = BHeight - 35
		lastBposx = 0
		lastBposy = 0
		Bposx = 0
		Bposy = 0
		v_x = 0
		v_y = 0
		Redraw()
	############################################################################
	############################################################################



################
def bevent(evt):

	if evt == 1: #Render
		main()
		Blender.Redraw()

	elif evt == 2: #Exit
		Exit()

	if (evt == 3) and lastUndo:
		print "Undoing..."
		Undo()
		print "Undo...OK."
		Blender.Redraw()

Register(draw, event, bevent)
#############################